﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using ScrabbleClient.Domain;
using ServerLibrary.WCF.DTO;

namespace ScrabbleClient.Interface
{
    /// <summary>
    /// Lógica de interacción para EditBoards.xaml
    /// </summary>
    public partial class EditBoards : Window
    {
        private List<BoardDTO> boards;
        public EditBoards()
        {
            InitializeComponent();
        }

        private void frmEditBoards_Loaded(object sender, RoutedEventArgs e)
        {
            GetUserBoards();
        }

        private void GetUserBoards()
        {
            boards = ClientManager.Instance.GetUserBoards();
            dgBoards.ItemsSource = boards;
        }           

        private void btnNewBoard_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                EditBoard eb = new EditBoard();
                eb.Owner = this;
                eb.NewBoard();
                eb.ShowDialog();
                GetUserBoards();
            }
            catch (Exception ex)
            {
                MessageBox.Show(this, ex.Message, "Error", MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }

        private void btnEditBoard_Click(object sender, RoutedEventArgs e)
        {
            
            if (dgBoards.SelectedItem == null)
            {
                MessageBox.Show(this, "No hi ha cap tauler seleccionat", "Error");
                return;
            }

            try
            {
                EditBoard eb = new EditBoard();
                eb.Owner = this;
                eb.LoadBoard((BoardDTO)dgBoards.SelectedItem);            
                eb.ShowDialog();
                GetUserBoards();
            }
            catch (Exception ex)
            {
                MessageBox.Show(this, ex.Message, "Error", MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }

        private void btnDeleteBoard_Click(object sender, RoutedEventArgs e)
        {
            if (dgBoards.SelectedItem == null)
            {
                MessageBox.Show(this, "No hi ha cap tauler seleccionat", "Error");
                return;
            }

            if (MessageBox.Show(this, "Estas segur que vols eliminar el tauler?", "Confirmació", MessageBoxButton.YesNo, MessageBoxImage.Question) != MessageBoxResult.Yes)
            {
                return;
            }

            try
            {
                ClientManager.Instance.DeleteBoard((BoardDTO)dgBoards.SelectedItem);
                GetUserBoards();
            }
            catch (Exception ex)
            {
                MessageBox.Show(this, ex.Message, "Error", MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }

        private void btnBack_Click(object sender, RoutedEventArgs e)
        {
            this.Close();
        }
    }
}
