﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using ScrabbleClient.Domain;
using ServerLibrary.WCF.DTO;

namespace ScrabbleClient.Interface
{
    /// <summary>
    /// Lógica de interacción para EditDictionaryInfos.xaml
    /// </summary>
    public partial class EditDictionaryInfos : Window
    {
        private List<DictionaryInfoDTO> dictionaries;
        public EditDictionaryInfos()
        {
            InitializeComponent();
        }

        private void frmEditDictionaryInfos_Loaded(object sender, RoutedEventArgs e)
        {
            GetDictionaries();
        }

        private void GetDictionaries()
        {
            dictionaries = ClientManager.Instance.GetDictionaries();
            dgDictionaries.ItemsSource = dictionaries;
        }           

        private void btnNewDictionary_Click(object sender, RoutedEventArgs e)
        {
            EditDictionaryInfo ed = new EditDictionaryInfo();
            ed.Owner = this;
            ed.NewDictionaryInfo();
            ed.ShowDialog();
            GetDictionaries();
        }

        private void btnEditDictionary_Click(object sender, RoutedEventArgs e)
        {
            
            if (dgDictionaries.SelectedItem == null)
            {
                MessageBox.Show(this, "No hi ha cap diccionari seleccionat", "Error");
                return;
            }

            try
            {
                EditDictionaryInfo ed = new EditDictionaryInfo();
                ed.Owner = this;
                ed.LoadDictionaryInfo((DictionaryInfoDTO)dgDictionaries.SelectedItem);             
                ed.ShowDialog();
                GetDictionaries();
            }
            catch (Exception ex)
            {
                MessageBox.Show(this, ex.Message, "Error", MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }

        private void btnDeleteDictionary_Click(object sender, RoutedEventArgs e)
        {
            if (dgDictionaries.SelectedItem == null)
            {
                MessageBox.Show(this, "No hi ha cap diccionari seleccionat", "Error");
                return;
            }

            if (MessageBox.Show(this, "Estas segur que vols eliminar el diccionari?", "Confirmació", MessageBoxButton.YesNo, MessageBoxImage.Question) != MessageBoxResult.Yes)
            {
                return;
            }

            try
            {
                ClientManager.Instance.DeleteDictionary((DictionaryInfoDTO)dgDictionaries.SelectedItem);
                GetDictionaries();
            }
            catch (Exception ex)
            {
                MessageBox.Show(this, ex.Message, "Error", MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }

        private void btnBack_Click(object sender, RoutedEventArgs e)
        {
            this.Close();
        }
    }
}
