﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using ScrabbleClient.Domain;
using ServerLibrary.WCF.DTO;

namespace ScrabbleClient.Interface
{
    /// <summary>
    /// Lógica de interacción para EditBoards.xaml
    /// </summary>
    public partial class EditTileSets : Window
    {
        private List<TileSetDTO> tileSets;
        public EditTileSets()
        {
            InitializeComponent();
        }

        private void frmEditBoards_Loaded(object sender, RoutedEventArgs e)
        {
            GetUserTileSets();
        }

        private void GetUserTileSets()
        {
            tileSets = ClientManager.Instance.GetUserTileSets();
            dgTileSets.ItemsSource = tileSets;
        }           

        private void btnNewTileSet_Click(object sender, RoutedEventArgs e)
        {
            EditTileSet ets = new EditTileSet();
            ets.Owner = this;
            ets.NewTileSet();
            ets.ShowDialog();
            GetUserTileSets();
        }

        private void btnEditTileSet_Click(object sender, RoutedEventArgs e)
        {

            if (dgTileSets.SelectedItem == null)
            {
                MessageBox.Show(this, "No hi ha cap sac de fitxes seleccionat", "Error");
                return;
            }

            try
            {
                EditTileSet ets = new EditTileSet();
                ets.Owner = this;
                ets.LoadTileSet((TileSetDTO)dgTileSets.SelectedItem);         
                ets.ShowDialog();
                GetUserTileSets();
            }
            catch (Exception ex)
            {
                MessageBox.Show(this, ex.Message, "Error", MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }

        private void btnDeleteTileSet_Click(object sender, RoutedEventArgs e)
        {
            if (dgTileSets.SelectedItem == null)
            {
                MessageBox.Show(this, "No hi ha cap sac de fitxes seleccionat", "Error");
                return;
            }

            if (MessageBox.Show(this, "Estas segur que vols eliminar el sac de fitxes?", "Confirmació", MessageBoxButton.YesNo, MessageBoxImage.Question) != MessageBoxResult.Yes)
            {
                return;
            }

            try
            {
                ClientManager.Instance.DeleteTileSet((TileSetDTO)dgTileSets.SelectedItem);
                GetUserTileSets();
            }
            catch (Exception ex)
            {
                MessageBox.Show(this, ex.Message, "Error", MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }

        private void btnBack_Click(object sender, RoutedEventArgs e)
        {
            this.Close();
        }
    }
}
