﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using ScrabbleClient.Domain;
using ServerLibrary.WCF.DTO;

namespace ScrabbleClient.Interface
{
    /// <summary>
    /// Lógica de interacción para FindGame.xaml
    /// </summary>
    public partial class FindGame : Window
    {
        private List<GameInfoDTO> games;
        public FindGame()
        {
            InitializeComponent();
        }
        
        private void frmNewGame_Loaded(object sender, RoutedEventArgs e)
        {
            try
            {
                GetAvailableGames();
            }
            catch (Exception ex)
            {
                MessageBox.Show(this, ex.Message, "Error", MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }

        private void GetAvailableGames()
        {
            games = ClientManager.Instance.GetAvailableGames();
            dgGames.ItemsSource = games;
        }

        private void btnBack_Click(object sender, RoutedEventArgs e)
        {
            this.Close();
        }

        private void btnPlayGame_Click(object sender, RoutedEventArgs e)
        {
            if (dgGames.SelectedItem == null)
            {
                MessageBox.Show(this, "No hi ha cap partida seleccionada", "Error");
                return;
            }

            //Afegir-se a la partida
            try
            {
                GameInfoDTO gameInfo = ClientManager.Instance.AddMeAsSecondPlayer(((GameInfoDTO)dgGames.SelectedItem).Id);
                PlayGame pg = new PlayGame();
                pg.Owner = this.Owner;
                pg.SetGame(gameInfo, true);
                this.Visibility = System.Windows.Visibility.Hidden;
                pg.ShowDialog();
                this.Close();
            }
            catch (Exception ex)
            {
                MessageBox.Show(this, ex.Message, "Error", MessageBoxButton.OK, MessageBoxImage.Error);
            }
            
        }

        private void btnRefresh_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                GetAvailableGames();
            }
            catch (Exception ex)
            {
                MessageBox.Show(this, ex.Message, "Error", MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }
    }
}
