﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.ServiceModel;
using System.ServiceModel.Description;
using ServerLibrary;

namespace ServerConsoleHost
{
    class Program
    {
        static void Main(string[] args)
        {
            ServiceHost scrabbleHost = null;
            try
            {
                scrabbleHost = new ServiceHost(typeof(ScrabbleService));

                scrabbleHost.Faulted += new EventHandler(ScrabbleHost_Faulted);
                scrabbleHost.Open();

                Console.WriteLine("The Scrabble service is running and is listening on:");
                foreach (ServiceEndpoint endpoint in scrabbleHost.Description.Endpoints)
                {
                    Console.WriteLine("{0} ({1})", endpoint.Address.ToString(), endpoint.Binding.Name);
                }
                Console.WriteLine("\nPress any key to stop the service.");
                Console.ReadLine();
            }
            finally
            {
                if (scrabbleHost.State == CommunicationState.Faulted)
                {
                    scrabbleHost.Abort();
                }
                else
                {
                    scrabbleHost.Close();
                }
            }
        }

        static void ScrabbleHost_Faulted(object sender, EventArgs e)
        {
            Console.WriteLine("The ScrabbleService host has faulted.");
        }
    }
}
