﻿using System;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ServerLibrary.Utils;

namespace ServerLibrary.Domain.Dictionaries
{
    /**
     * Classe que implementara un diccionari per consultar la validesa de les paraules en forma de trie:
     * http://en.wikipedia.org/wiki/Trie
     * 
     * */
    public class TrieDictionary : IScrabbleDictionary
    {
        Trie dictionary = new Trie();

        public string Id { get; set; }

        public string Name { get; set; }

        public string FileName { get; set; }

        public Trie InternalStruct { get { return dictionary; } }

        public bool ContainsWord(string word)
        {
            return dictionary.SearchWord(word);
        }

        public bool ContainsPrefix(string prefix)
        {
            return dictionary.SearchPrefix(prefix);
        }

        public void Initialize()
        {
            using (StreamReader file = new StreamReader(FileName))
            {
                string word;
                while ((word = file.ReadLine()) != null)
                {
                    dictionary.Insert(word);
                }
            }
        }
    }
}
