﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ServerLibrary.Domain.TileSets;
using ServerLibrary.Domain.Users;
using ServerLibrary.Domain.Errors;
using ServerLibrary.WCF.DTO;

namespace ServerLibrary.Domain.Games
{
    public abstract class BasePlayer: IPlayer
    {
        //Referència al joc en el que participa aquest jugador
        protected Game game;
        protected int score = 0;

        //Faristol amb les fitxes actuals del jugador
        protected Rack rack = new Rack();

        public virtual Game Game { set { game = value; } }
        public virtual string Name { get { return ""; } }
        public virtual string Id { get { return ""; } }
        public virtual int Score { get { return score; } set { score = value; } }
        public virtual Rack Rack { get { return rack; } set { rack = value; } }


        public abstract void YourTurn();
        public abstract void OpponentResigned();

        public virtual void AttachUser(User user)
        {
            ScrabbleError.GetNewFaultException("No es pot vincular un usuari a aquest tipus de jugador", ScrabbleError.GAME_PLAYER_TYPE_DOES_NOT_ALLOW_USER);
        }

        public virtual void DetachUser()
        {
            ScrabbleError.GetNewFaultException("No es pot desvincular un usuari d'aquest tipus de jugador", ScrabbleError.GAME_PLAYER_TYPE_DOES_NOT_ALLOW_USER);
        }

        public virtual bool IsUserAttached()
        {
            return false;
        }
    }
}
