﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ServerLibrary.Domain.Users;
using ServerLibrary.Domain.TileSets;
using ServerLibrary.WCF.DTO;

namespace ServerLibrary.Domain.Games
{
    public class HumanPlayer: BasePlayer
    {
        private User user;
        private string id;
        private string name;

        //Passem l'id i el nom per separat perque en alguns casos podem crear l'objecte sense usuari adjunt
        //(Per exemple al carregar una partida de la base de dades per l'altre jugador)
        public HumanPlayer(User user, string id, string name)
        {
            this.user = user;
            this.id = id;
            this.name = name;
        }

        public override string Name { get { return (user!=null?user.Name: name); } }

        public override string Id { get { return (user != null ? user.Id : id); } }

        public override void YourTurn()
        {
            if (user != null)
            {
                user.ClientCallback.YourTurn(game.ToDTO(), game.Board.ToDTO(), Rack.ToDTO(), game.LastMoveInfo);
            }
        }

        public override void OpponentResigned()
        {
            if (user != null)
            {
                user.ClientCallback.OpponentResigned(game.ToDTO());
            }
        }

        public override void AttachUser(User user)
        {
            if (this.user == null)
            {
                this.user = user;
            }
        }

        public override void DetachUser()
        {
            if (user != null)
            {
                user = null;
            }
        }

        public override bool IsUserAttached()
        {
            return (user != null);
        }
    }
}
