﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Configuration;
using System.Threading.Tasks;
using System.IdentityModel.Selectors;
using ServerLibrary.LINQ.Context;
using ServerLibrary.LINQ.Entity;
using ServerLibrary.Domain.Errors;
using System.ServiceModel;

namespace ServerLibrary.Domain.Users
{
    //Classe que validarà de forma personalitzada les crides dels clients
    public class ScrabbleUserNameValidator : UserNamePasswordValidator
    {
        public override void Validate(string userName, string password)
        {
            //En primer lloc comprobem la validesa dels paràmetres
            if (null == userName || null == password || "" == userName || "" == password)
            {
                throw ScrabbleError.GetNewFaultException("El nom d'usuari o el password no poden estar en blanc", ScrabbleError.USER_OR_PASSWORD_BLANK);
            }

            /*Cas especial d'identificació exclusivament per crear un nou usuari, 
             * l'usuari serà "CreateNewUser" i el password "{35CCFA7A-96D7-456A-A927-B67012EF13A7}"
             * En aquest cas no validem res, en qualsevol altre cas fem les comprovacions pertinents
             **/
            if (!(userName == "CreateNewUser" && password == "{35CCFA7A-96D7-456A-A927-B67012EF13A7}"))
            {
                //Cerquem l'usuari i la contrassenya a la base de dades mitjançant LINQ               
                int count;
                try
                {
                    string connStr = ConfigurationManager.ConnectionStrings["ServerLibrary.Properties.Settings.SCRABBLEConnectionString"].ConnectionString;
                    ScrabbleClassesDataContext dataContext = new ScrabbleClassesDataContext(connStr);

                    count = (from user in dataContext.USER
                             where user.name == userName && user.password == password
                             select user).Count();
                }
                catch (Exception ex)
                {
                    throw ScrabbleError.GetNewFaultException("Error inesperat accedint a base de dades:\n" + ex.Message, ScrabbleError.DATABASE_UNEXPECTED_ERROR);
                }

                //En cas que no existeixi retornem un error
                if (count == 0)
                {
                    throw ScrabbleError.GetNewFaultException("L'usuari o la contrasenya son invalids", ScrabbleError.USER_OR_PASSWORD_INVALID);
                }
            }
        }
    }
}
