﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ServerLibrary.Utils
{
    //Classe que representarà un node del Trie
    public class TrieNode
    {
        private char letter;
        private bool isValidEnding;
        private Dictionary<char, TrieNode> children; //LLista de nodes successors classificats per lletra

        public TrieNode(char letter)
        {
            children = new Dictionary<char, TrieNode>();
            isValidEnding = false;
            this.letter = letter;
        }

        public char Letter { get { return letter; } set { letter = value; } }

        public bool IsValidEnding { get { return isValidEnding; } set { isValidEnding = value; } }

        public Dictionary<char, TrieNode> Children { get { return children; } set { children = value; } }

        public TrieNode ChildNode(char letter)
        {
            TrieNode result = null;

            children.TryGetValue(letter,out result);

            return result;
        }

        public TrieNode Add(char letter)
        {
            TrieNode result = new TrieNode(letter);
            children.Add(letter, result);

            return result;
        }
    }
}
